<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>

<% if current_user.nil? %>
<%= link_to 'Please login to view your playlists.', new_user_session_path %>
<% end %>
<% unless current_user.nil? %>
  <% playlists = Playlist.where(user_id: current_user.id) %>
  <div class="Playlist-index">
    <div class="page-title-wrapper mb-3">
      <div class="row">
        <div class="col-sm-6">
          <h1 class="page-title">Playlists <small>(<%= playlists.size %> total)</small></h1>
        </div>
          <div class="<% if !playlists.empty? %>col-sm-6 text-right<% end %>">
            <div class="create-buttons">
              <%= link_to('<span class="btn btn-primary headline-button">Create New Playlist</span>'.html_safe, new_playlist_path) %>
              <% if Settings['variations'].present? %>
                <%= form_tag(import_variations_playlist_playlists_path, method:"post", enctype:"multipart/form-data", style:"display:inline") do %>
                  <input type="file" name="Filedata" class="filedata" style="visibility:hidden; display:inline; width:0;" />
                  <input type="button" class="btn btn-primary" id="variations_import"
                    onclick="$(this).closest('form').find('.filedata').click();" value="Import Variations Playlist" />
                <% end %>
              <% end %>
            </div>
          </div>
      </div>
    </div>

    <% unless playlists.empty? %>
      <div class="tag_filter_container">
        Filter by tag: <select name="tag_filter" class="tag_filter form-control input-sm" style="width:auto">
          <option value="" selected="selected">None</option>
          <% current_user.playlist_tags.each do |tag| %>
          <option value="<%= tag %>"><%= tag %></option>
          <% end %>
        </select>
      </div>
      <table id="Playlists" class="table table-striped dataTable">
        <thead>
          <tr>
            <th>Name</th>
            <th>Size</th>
            <th>Visibility</th>
            <th>Created</th>
            <th>Updated</th>
            <th>Tags</th>
            <th class="text-right" data-orderable="false">Actions</th>
          </tr>
        </thead>
        <tbody>
        </tbody>
      </table>
    <% end %>
  </div>
  <% unless !playlists.empty? %>
  <% end %>
<% end %>

<%= render partial: 'copy_playlist_modal', locals: { with_refresh: true } %>

<% content_for :page_scripts do %>
<script>
  $(document).ready(function () {
    $('#Playlists').DataTable({
      processing: true,
      serverSide: true,
        dom:'<"dataTableToolsTop"if><"dataTableBody"t><"dataTableToolsBottom"rlp>',
      autoWidth:true,
      ajax: {
        url: '/playlists/paged_index',
        type: 'POST'
      },
      order: [ <%= "[#{session[:playlist_sort][0]}, '#{session[:playlist_sort][1]}']".html_safe if session[:playlist_sort] %>
      ],
      "columns": [
        null,
        null,
        null,
        null,
        null,
        null,
        {
          className: "text-right"
        }
      ]
    }).on('draw', function () {
      window.apply_button_confirmation()
      window.add_copy_playlist_button_event()
      // move the tag filter into the datatables layout
      $('.tag_filter_container').insertBefore('.dataTables_filter');
    });
  });

  $('.tag_filter').change(function () {
    $.fn.dataTable.tables({
      api: true
    }).columns(5).search($(this).val()).draw();
  })

  $('.filedata').change(function () {
    $(this).closest('form').submit();
  });
</script>
<% end %>
